#!/bin/sh
# --- SDE-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# Filename: target/idunn/initramfs/init.sh
# Copyright (C) 2008 - 2009 The OpenSDE Project
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- SDE-COPYRIGHT-NOTE-END ---

export PATH

LOG=/var/log/init.log

# catch some signals
#
shutoff_handler() {
	local x=

	# just once!
	ln -s / /var/run/init.lock 2> /dev/null || return

	# stop services
	/etc/rc.d/rc.shutdown -u

	case "$1" in
	USR1)	halt -f ;;
	USR2)	poweroff -f ;;
	*)	reboot -f ;;
	esac
}

for x in USR1 USR2 TERM INT; do
	trap "shutoff_handler $x" $x
done
unset x

# start the world
(
/etc/rc.d/rc.sysinit
/etc/rc.d/rc.trymount
if [ ! -e /var/run/.idunn-stop ]; then
	/etc/rc.d/rc.tryresume
fi
) 2>&1 | tee -a $LOG

if [ ! -e /var/run/.idunn-resume ]; then
	# attach a console
	ln -s /etc/console /var/service/
fi

while true; do
	sleep 1;
	if [ -e /var/run/.idunn-resume ]; then
		# switch_root requested
		. /etc/conf/idunn

		echo "switch_root in progress, you will be disconnected now." | wall

		# stop services
		/etc/rc.d/rc.shutdown

		# terminate the rest
		/etc/rc.d/rc.switchroot stop

		# and proceed
		exec switch_root -c /dev/console "$rootfs" "$init" $initopt
	fi
done
